//+-----------------------------------------------------------------+
//| Price Zone 1                                                    |
//| Original auther is unknown, modification by -IXI-.              |
//+-----------------------------------------------------------------+
#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1  LimeGreen
#property indicator_color2  Orange
#property indicator_color3  Orange
#property indicator_color4  LightSlateGray
#property indicator_color5  LightSlateGray
#property indicator_color6  LimeGreen
#property indicator_color7  Orange
#property indicator_width1  3
#property indicator_width2  3
#property indicator_width3  3
#property indicator_width4  1
#property indicator_width5  1
#property strict

//
//
//
//
//

extern string TimeFrame       = "current time frame"; // time frame to use
extern int    Length          = 20;    // price channel length
extern double Deviation       = 2.0;   // deviation multiplier
extern bool   alertsOn        = true;  // turn alert on
extern bool   alertsOnCurrent = false; // alert on current bar
extern bool   alertsOnHighLow = true;  // alert on high low break
extern bool   alertsMessage   = true;  // display popup alert
extern bool   alertsSound     = false; // play sound for alert
extern bool   alertsNotify    = false; // send notification alert
extern bool   alertsEmail     = false; // send email alert
extern bool   Interpolate     = true;  // interpolate in multi time frame mode
extern int    arrowSize       = 1;     // arrow size
extern int    arrowCodeUp     = 108;   // arrow code up (use 241 for up arrow)
extern int    arrowCodeDown   = 108;   // arrow code down (use 242 for down arrow)
extern bool   arrowsVisible   = true;  // should arros be visible


//
//
//
//
//

double Middle[];
double MiddleI[];
double MiddleII[];
double Upper[];
double Lower[];
double Slope[];
double arrowUp[];
double arrowDn[];
double trend[];
double cross[];

string indicatorFileName;
bool   returnBars;
int    timeFrame;

//-------------------------------------------------------
//
//-------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(10);
   SetIndexBuffer(0,Middle);
   SetIndexBuffer(1,MiddleI);
   SetIndexBuffer(2,MiddleII);
   SetIndexBuffer(3,Upper);
   SetIndexBuffer(4,Lower);
   SetIndexBuffer(5,arrowUp); if (arrowsVisible) { SetIndexStyle(5,DRAW_ARROW,0,arrowSize); SetIndexArrow(5,arrowCodeUp  );} else SetIndexStyle(5,DRAW_NONE);
   SetIndexBuffer(6,arrowDn); if (arrowsVisible) { SetIndexStyle(6,DRAW_ARROW,0,arrowSize); SetIndexArrow(6,arrowCodeDown);} else SetIndexStyle(5,DRAW_NONE);
   SetIndexBuffer(7,Slope);
   SetIndexBuffer(8,trend);
   SetIndexBuffer(9,cross);
   
   
   timeFrame         = stringToTimeFrame(TimeFrame);
   indicatorFileName = WindowExpertName();
   returnBars        = TimeFrame == "returnBars"; if (returnBars) return(0);
   
   IndicatorShortName("Price Zone("+(string)Length+")");
return(0);
}
int deinit() { return(0); }

//-------------------------------------------------------
//
//-------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if (counted_bars<0) return(-1);
      if (counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-2);
         if (returnBars) { Middle[0] = limit+1; return(0); }
         if (timeFrame!=Period())
         {
            limit = (int)MathMin(MathMax(limit,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()),Bars-2);
            if (Slope[limit]==-1) CleanPoint(limit,MiddleI,MiddleII);
            for(int i=limit; i>=0; i--)
            {
               int y = iBarShift(NULL,timeFrame,Time[i]);  
                 Middle[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Length,Deviation,alertsOn,alertsOnCurrent,alertsOnHighLow,alertsMessage,alertsSound,alertsNotify,alertsEmail,0,y); 
                 MiddleI[i]  = EMPTY_VALUE;
	              MiddleII[i] = EMPTY_VALUE;       
                 Upper[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Length,Deviation,alertsOn,alertsOnCurrent,alertsOnHighLow,alertsMessage,alertsSound,alertsNotify,alertsEmail,3,y);
                 Lower[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Length,Deviation,alertsOn,alertsOnCurrent,alertsOnHighLow,alertsMessage,alertsSound,alertsNotify,alertsEmail,4,y);
                 Slope[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Length,Deviation,alertsOn,alertsOnCurrent,alertsOnHighLow,alertsMessage,alertsSound,alertsNotify,alertsEmail,7,y);
                 cross[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Length,Deviation,alertsOn,alertsOnCurrent,alertsOnHighLow,alertsMessage,alertsSound,alertsNotify,alertsEmail,9,y);
                 if (cross[i]!=cross[i+1])
                 {
                     if (cross[i] ==  1 || cross[i] == 2) arrowDn[i] = Upper[i] + iATR(NULL,0,20,i)/2.0;
                     if (cross[i] == -1 || cross[i] == 2) arrowUp[i] = Lower[i] - iATR(NULL,0,20,i)/2.0;
                 }                  
                      
                 //
                 //
                 //
                 //
                 //
                        
                 if (!Interpolate || (i!=0 && y==iBarShift(NULL,timeFrame,Time[i-1]))) continue;

                 //
                 //
                 //
                 //          
                 //

                 int n,k; datetime time = iTime(NULL,timeFrame,y);
                    for(n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
                    for(k = 1; k < n && (i+k)<Bars && (i+n)<Bars; k++)
                    {
  	                    Middle[i+k] = Middle[i] + (Middle[i+n] - Middle[i]) * k/n;
  	                    Upper[i+k]  = Upper[i]  + (Upper[i+n]  - Upper[i])  * k/n;
  	                    Lower[i+k]  = Lower[i]  + (Lower[i+n]  - Lower[i])  * k/n;
                    }  	                             
            } 
         for(int i=limit; i>=0; i--) if (Slope[i] == -1) PlotPoint(i,MiddleI,MiddleII,Middle);
         return(0);
         }
         
   //
   //
   //
   //
   //
   
   if (Slope[limit]==-1) CleanPoint(limit,MiddleI,MiddleII);
   for (int i = limit; i>=0; i--)
   {	
	   double CloseMA     = iEma(Close[i]      ,Length,i,0);
	   double HLMA        = iEma(High[i]-Low[i],Length,i,1);
	   double APZRange    = iEma(HLMA          ,Length,i,2);
	          Middle[i]   = iEma(CloseMA       ,Length,i,3);
	          Upper[i]    = Middle[i]+APZRange*Deviation;
	          Lower[i]    = Middle[i]-APZRange*Deviation;
	          Slope[i]    = Slope[i+1];
	          cross[i]    = 0;
	          MiddleI[i]  = EMPTY_VALUE;
	          MiddleII[i] = EMPTY_VALUE;
	          arrowUp[i]  = EMPTY_VALUE;
	          arrowUp[i]  = EMPTY_VALUE;
   	          if (Middle[i] > Middle[i+1]) Slope[i] =  1;
                if (Middle[i] < Middle[i+1]) Slope[i] = -1;
                if (High[i] > Upper[i] && Low[i] >= Lower[i]) cross[i] =  1;
                if (Low[i] < Lower[i] && High[i] <= Upper[i]) cross[i] = -1;
                if (High[i] > Upper[i] && Low[i] <  Lower[i]) cross[i] =  2;
                if (cross[i]!=cross[i+1])
                {
                  if (cross[i] ==  1 || cross[i] == 2) arrowDn[i] = Upper[i] + iATR(NULL,0,20,i)/2.0;
                  if (cross[i] == -1 || cross[i] == 2) arrowUp[i] = Lower[i] - iATR(NULL,0,20,i)/2.0;
                }                  
                if (Slope[i] == -1) PlotPoint(i,MiddleI,MiddleII,Middle);
                
                //
                //
                //
                //
                //
                
                trend[i] = 0;                     
                if (alertsOnHighLow)       
                {
                  if (High[i] > Upper[i]) trend[i] = -1;
                  if (Low[i]  < Lower[i]) trend[i] =  1;
                }
                else
                {
                  if (Close[i] > Upper[i]) trend[i] = -1;
                  if (Close[i] < Lower[i]) trend[i] =  1;
                }
   }
   manageAlerts();
	return(0);
}

//-------------------------------------------------------
//
//-------------------------------------------------------
//
//
//
//
//

double workEma[][4];
double iEma(double price, double period, int r, int instanceNo=0)
{
   if (ArrayRange(workEma,0)!= Bars) ArrayResize(workEma,Bars); r = Bars-r-1;

   //
   //
   //
   //
   //
      
   double alpha = 2.0 / (1.0+period);
          workEma[r][instanceNo] = workEma[r-1][instanceNo]+alpha*(price-workEma[r-1][instanceNo]);
   return(workEma[r][instanceNo]);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if (i>=Bars-2) return;
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (i>=Bars-2) return;
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}
 
//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M10","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,10,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   StringToUpper(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+(string)iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                              return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      int whichBar = 1; if (alertsOnCurrent) whichBar = 0; 
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"lower");
         if (trend[whichBar] ==-1) doAlert(whichBar,"upper");
      }         
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(timeFrameToString(Period())+" "+Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Price Zone price touching ",doWhat," band");
          if (alertsMessage) Alert(message);
          if (alertsNotify)  SendNotification(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Price Zone "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}